﻿using C1.Win.C1FlexGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ClearFiltering.FlexGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            c1FlexGrid1.DataSource = GetDataTable();
        }

        private void clearFilteringToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Here, Filter object is assigned to columns
            //and now, the filter dropdown only shown this Filter
            ConditionFilter filterNoAtc = new ConditionFilter();
            filterNoAtc.Condition1.Operator = ConditionOperator.DoesNotContain;
            filterNoAtc.Condition1.Parameter = "IT";
            c1FlexGrid1.Cols["Department"].Filter = filterNoAtc;
            c1FlexGrid1.ApplyFilters();
        }

        private void clearFilterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //this method just resets all the filters and does not remove the Filter objects assigned to a Column
            //c1FlexGrid1.ClearFilter();

            /*If the Column.Filter property contains a ConditionFilter or a ValueFilter object, 
            then only that is shown in the Filter dropdown*/
            //To resolve this, set the Filter property to null
            c1FlexGrid1.Cols["Department"].Filter = null;
        }

        /// <summary>
        /// Sample Data for the Grid
        /// </summary>
        /// <returns>DataTable</returns>
        private DataTable GetDataTable()
        {
            DataTable dt = new DataTable("Employees");
            dt.Columns.Add("Id", typeof(int));
            dt.Columns.Add("Name", typeof(string));
            dt.Columns.Add("Department", typeof(string));
            dt.Columns.Add("Sex", typeof(string));
            dt.Columns.Add("Salary", typeof(decimal));

            dt.Rows.Add(1, "Peter", "Mgmt", "M", 5000);
            dt.Rows.Add(2, "George", "ACC", "M", 4000);
            dt.Rows.Add(3, "Frank", "IT", "M", 4500);
            dt.Rows.Add(4, "Linda", "IT", "F", 4000);
            dt.Rows.Add(5, "Fink", "ACC", "M", 3000);
            dt.Rows.Add(6, "Lucy", "ACC", "F", 5000);

            return dt;
        }
    }
}
